/*
 * Avoid portability and in_addr nonsense.
 */

#define IPPROTO_ICMP            1

typedef struct ip {
#if BYTE_ORDER == LITTLE_ENDIAN
    u_int8_t   ip_hl:4,
               ip_v:4;
#endif
#if BYTE_ORDER == BIG_ENDIAN
    u_int8_t   ip_v:4,
               ip_hl:4;
#endif
    u_int8_t  ip_tos;
    u_int16_t ip_len;
    u_int16_t ip_id;
    u_int16_t ip_off;
#define IP_RF           0x8000
#define IP_DF           0x4000
#define IP_MF           0x2000
#define IP_OFFMASK      0x1fff
    u_int8_t  ip_ttl;
    u_int8_t  ip_p;
    u_int16_t ip_sum;
    u_int32_t  ip_src;
    u_int32_t  ip_dst;
} iph_t;

typedef struct icmp {
    u_int8_t  icmp_type;
    u_int8_t  icmp_code;
    u_int16_t icmp_cksum;
    u_int16_t echo_id;
    u_int16_t echo_seqno;
} icmph_t;
